import java.io.*;
import java.util.Scanner;

/**
 * Add Javadoc comment
 */
public class Image {

    // These instance variables are all initialized by the open() method
    private int height;
    private int width;
    private Pixel[][] canvas;

    /**
     * Creates a new image from the specified file
     */
    public Image(String filename){
        open(filename);
    }

    // PLEASE WRITE YOUR CODE HERE
    
    
    
    
    
    
    
    
    
    
    
    
    /************************************************************
     * DO NOT EDIT ANYTHING BELOW THIS COMMENT
     * 
     * READ THE METHODS' COMMENTS AND SIGNATURE
     * TO UNDERSTAND HOW TO USE THEM IN YOUR CODE
     *************************************************************/

    /**
     * Creates a String representation of this image. The format is:
     * PPM_VERSION
     * width height
     * 255
     * (pixel values)
     * 
     * @param A string representing the image
     */
    public String toString() {
        StringBuffer strBuffer = new StringBuffer();
        strBuffer.append("P2\n");
        strBuffer.append(this.width + " " + this.height + "\n");
        strBuffer.append("255\n");
        for(int i=0 ; i<this.height; i++) {
            for(int j=0; j<this.width; j++) {
                strBuffer.append(this.canvas[i][j].getValue() + " "); 
            }
            strBuffer.append("\n");
        }        
        return strBuffer.toString();       
    }

    
    /**
     * Opens a PPM file and stores the values in a 2D array of pixels
     * 
     * @param   filename is a path to the PPM file to be opened
     */
    public void open(String filename)
    {        
        File f = new File(filename);
        try {
            System.err.print("Opening " + filename + "... ");

            //use Scanner on the file for input
            Scanner fileScanner = new Scanner(f);

            //read in PPM version
            //this.PPMversion = fileScanner.nextLine();
            //if (this.PPMversion.equalsIgnoreCase("P2"))
            String PPMversion = fileScanner.nextLine();
            if (PPMversion.equalsIgnoreCase("P2")){
                String line;

                //skip comments (starts with #)
                while ((line = fileScanner.nextLine()).startsWith("#"))
                    ;

                //get and set dimensions
                String[] dim = line.split("\\s");
                this.width = Integer.parseInt(dim[0]);
                this.height = Integer.parseInt(dim[1]);

                //initialize the pixel 2D array
                this.canvas = new Pixel[this.height][this.width];

                //read and discard the maximum pixel value (should be 255)
                fileScanner.nextInt();

                //read in the pixels
                for (int i=0; i<this.height; i++){
                    for (int j=0;  j<this.width; j++){
                        this.canvas[i][j] = new Pixel(fileScanner.nextInt());
                    }
                }

                System.err.println("Success!");
            }
            else{
                System.err.println("PPM version " + PPMversion + " does not support ASCII. Exiting...");
                System.exit(-1);
            }
        }
        catch(IOException e){
            System.err.println("Problem opening: " + filename + ". Exiting...");
            System.exit(-1);
        }
    }

    
    /**
     * Writes contents of current Image into the file specified
     * 
     * @param   filename    The name of file into which to save current image.
     */
    public void save(String filename)
    {
        File f = new File(filename);
        try {
            System.err.println("Saving " + filename + "... ");

            //open file for writing
            PrintWriter fileOut = new PrintWriter(f);

            //get string representation of file and print it out to file
            fileOut.print(this.toString());

            //close out the file
            fileOut.close();

            System.err.println("Success!");
        }
        catch(IOException e){
            System.err.println("Problem saving: " + filename + ". Exiting...");
            System.exit(-1);
        }
    }
}
